import java.awt.FlowLayout;
import java.awt.Font;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseEvent;
import java.util.Date;
import javax.swing.JApplet;
import javax.swing.JLabel;
import javax.swing.SwingUtilities;
import javax.swing.Timer;

public class DraggableClock3 extends JApplet {
    private JLabel clock;
    private Timer timer;

    private int modifierMask = -1;
    private int mouseButton = MouseEvent.BUTTON1;

    @Override
    public void init() {
        // hbOJñL[̐ݒ
        String modifierKey = getParameter("modifier");
        if ("ctrl".equalsIgnoreCase(modifierKey)) {
            modifierMask = MouseEvent.CTRL_MASK;
        } else if ("shift".equalsIgnoreCase(modifierKey)) {
            modifierMask = MouseEvent.SHIFT_MASK;
        } else if ("alt".equalsIgnoreCase(modifierKey)) {
            modifierMask = MouseEvent.ALT_MASK;
        }

        // hbOJñ}EX{^̐ݒ
        String mouseButtonTxt = getParameter("button");
        if ("2".equalsIgnoreCase(mouseButtonTxt)) {
            mouseButton = MouseEvent.BUTTON2;
        } else if ("3".equalsIgnoreCase(mouseButtonTxt)) {
            mouseButton = MouseEvent.BUTTON3;
        }

        SwingUtilities.invokeLater(new Runnable() {
            public void run() {
                // v\郉x̐ݒ
                clock = new JLabel();
                Font font = clock.getFont();
                font = new Font(font.getFamily(), Font.BOLD, 20);
                clock.setFont(font);
 
                setLayout(new FlowLayout());
                //                add(clock);
                javax.swing.JButton button = new javax.swing.JButton("Open");
                button.addActionListener(new ActionListener() {
                    public void actionPerformed(ActionEvent event) {
                        try {
                            DraggableClock3.this.getAppletContext().showDocument(new java.net.URL("file:///C:/Program%20Files/Java/jdk1.6.0_14/docs/ja/api/index.html"));
                        }catch(Exception ex) {ex.printStackTrace();}
                    }
                });
                add(button);
            }
        });
    }
 
    @Override
    public void start() {
        SwingUtilities.invokeLater(new Runnable() {
            public void run() {
                // IɍsȂ
                ActionListener listener = new ActionListener() {
                    public void actionPerformed(ActionEvent event) {
                        clock.setText(new Date().toString());
                    }
                };
 
                // ^C}̐EJn
                timer = new Timer(1000, listener);
                timer.setRepeats(true);
                timer.start();
            }
        });
    }
 
    @Override
    public void stop() {
        SwingUtilities.invokeLater(new Runnable() {
            public void run() {
                // ^C}̏I
                timer.stop();
            }
        });
    }

    public boolean isAppletDragStart(MouseEvent event) {
        if ((event.getModifiers() & modifierMask) != 0
            && event.getButton() == mouseButton) {
            return true;
        } else {
            return false;
        }
    }
}